/* PISO_PEX-P16R16/PEX-P8R8 Linux Static Libary.

   Author: Winson Chen

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   Use vi or gvim to edit this file and set tabstop=4.

   v 0.0.0  20 Aug 2019 by Winson Chen
     function created for digital I/O and card_id.

*/

#include "piodio.h"
#include "inter.h"

WORD PISOP16R16_Digital_Output(WORD fd, WORD port, byte data)
{
	ixpio_reg_t reg;
	int id;
	
	switch (port)
	{
		case PISOP16R16_DIOA:
		case PISOP16R16_DIOB:
        		reg.id = port;
			reg.value = data;
		break;
		default:
			return PIODA_PORT_DEFINED_ERROR;
	}

	if (PIODA_OutputByte(fd, &reg)) return PIODA_DIGITAL_OUTPUT_ERROR;

	return SUCCESS;
}

WORD PISOP16R16_Digital_Input(WORD fd, WORD port, WORD *di_data)
{
	ixpio_reg_t reg;
	int id;

	switch (port)
	{
		case PISOP16R16_DIOA:
		case PISOP16R16_DIOB:
			reg.id = port;
		break;

		default:
			return PIODA_PORT_DEFINED_ERROR;
	}

	if (PIODA_InputByte(fd, &reg)) return PIODA_DIGITAL_INPUT_ERROR;

	*di_data = reg.value;
	return SUCCESS;
}

WORD PISOP16R16_Card_ID(WORD fd, byte *id)
{
	ixpio_reg_t reg;
	reg.id = IXPIO_CID;

	if (PIODA_InputByte(fd, &reg)) return PIODA_CARD_ID_ERROR;
	
	*id = reg.value;

	return SUCCESS;
}
